


if (process.env.automationRunTags == null)
{
    console.log('No env defined tags. Setting some Demo and debug tags manually')
    process.env.automationRunTags = '@sanity'
}

const logger = require('./node_modules/@cellebrite/automation-loggers/loggerModule');
const reportPortal = require('../automation/node_modules/@cellebrite/automation-report-portal/reportPortal');

// if (process.env.URL != null)
// {
//     console.log('No URL defined. using default URL')
//      globalConstants.URL = process.env.URL;
// }

reportPortal.startLaunch("UMS").then((res) => {
    
    process.env.launchId = res.body.id;
    //logger.info(`Report portal launch ID: ${res.body.id}`);
    var Launcher = require('webdriverio').Launcher;
    var wdio = new Launcher('./automation/wdio.conf.jenkins.js', {cucumberOpts: {tagExpression: process.env.automationRunTags}, ignoreUndefinedDefinitions: false, strict: true});
    const {spawnSync} = require('child_process');
    var ssrs =require('../automation/node_modules/@cellebrite/automation-reports/ssrs');
    const timestamp = new Date().toISOString();      

    if (process.env.automationSessionId == null)
    {
        console.log('Setting up the run timestamp')
        const moment = require('moment');
        const time = moment();
        var time_format = time.format('YYYYMMDD-HHmmssSSS');        
        process.env.automationSessionId = time_format;
    }

    console.log('Session selected tags: ' + process.env.automationRunTags)
    console.log('Automation session ID: ' + process.env.automationSessionId);
    
    wdio.run().then((code) => {                 
            reportPortal.finishLaunch(process.env.launchId);
            var result = spawnSync('node', ['./automation/node_modules/@cellebrite/automation-reports/generateHtmlReport.js'],{ shell: true });
            ssrs.updateSql("automation/json-report-4sql/"+process.env.automationSessionId,process.env.automationSessionId).then(() => {
                console.log('result: ' + result.status)
                process.exit(code);
            });
    }, (error) => {
            console.error('Launcher failed to start the test', error.stacktrace);
            process.exit(1);
        });
});


