import{sendRequest} from '../common/rest-api/sendRequest';
let scenarioWorld = require('@cellebrite/automation-wdio-helpers/scenarioWorld');
const logger = require('@cellebrite/automation-loggers/loggerModule');
const postOptionsTemplate = require('../api_objects/Queries/postOptions');

declare const constants :any;
declare const global : any;
export class contextsPage {
    constructor(){};
    static async createContextByAPI(contextName : string){
        logger.verbose("Creating context...");
        let jsonObject = constants["defaults request"];
        jsonObject.name = contextName;
        jsonObject.key = contextName;
        let postOptions = postOptionsTemplate.post;    
        postOptions.uri = global.runSettings.umsUrl + '/v1/contexts';
    
        logger.verbose("Sending request for creating context");
        let profileRes = await sendRequest.sendRequest(jsonObject,postOptions)
        logger.verbose("request sent");
        return profileRes;
    }
    static async isContextExistByName(contextName : string){
        
        logger.debug("checking context " + contextName +   "exist...");
        let contextList = await this.getContextsList();
        let contextExist = this.checkContextExistByName(contextList, contextName);
        return contextExist;
    
    }
    static async getContextsList(){
        let getOptions = postOptionsTemplate.get;    
        getOptions.uri = global.runSettings.umsUrl + '/v1/contexts';
        getOptions.resolveWithFullResponse = false;
        let contextsList = await sendRequest.sendRequest("{}",getOptions);
        logger.debug('request sent');
        return contextsList;
    }
    static checkContextExistByName(contextList : any, contextName : string){
        let i;
        for(i = 0;i < contextList.length; i++){
            if(contextList[i].name == contextName)
                return true;
        }
        return false;
    }
}

