
import { UmsUser } from '@cellebrite/automation-ums-authenticator/umsUser'
const auth = require('@cellebrite/automation-ums-authenticator/authenticator')
const logger = require('@cellebrite/automation-loggers/loggerModule');
const featureWorld = require("@cellebrite/automation-wdio-helpers/featureWorld");
declare const global: any;

// tslint:disable-next-line: class-name
export class loginPage {
    public static async loginToUmsByApi(userName: string, password: string) {
        if (!featureWorld.user || featureWorld.user.userName !== userName) {

            const token = await auth.authenticateUser(userName,
                                                    password, global.runSettings.grant_type,
                                                    global.runSettings.client_id,
                                                    global.runSettings.client_secret,
                                                    global.runSettings.scope, global.runSettings.response_type,
                                                    global.runSettings.issuer, global.runSettings.redirect_uri);

            if (token) {
                featureWorld.user = new UmsUser(userName, token);
                featureWorld.loginsucceed = true;
                logger.info(`Logged in with username: ${userName}, password: ${password}`);
            } else {
                featureWorld.loginsucceed = false;
                logger.error(`Login failed, username: ${userName}, password: ${password}`);
            }
        }
    }
}
