
const loginPageConstants = require('../constants/ui/loginPageConstants');
const constants = require('./constants');
//const CMSReportConstants = require('./page_constants/CMSReport');
//const deviceMonitorConstants = require('../page_constants/deviceMonitor');
//const districtPageConstants = require('./page_constants/districtPageConstants');
const siteMapConstants = require('../constants/ui/sitemapConstants');
//const unitConstants = require('./page_constants/unitConstants');
//const caseDetailsConstants = require('./page_constants/caseDetailsConstants');
const profilePageConstants = require('../constants/ui/profilePageConstants');
//const deviceConstants = require('./page_constants/deviceConstants');
//const userConstants = require('./page_constants/userConstants');
const requestConstant = require('../constants/api/requestConstants');
const userConstants = require('../constants/api/userConstants');
const searchStringConstants = require('../constants/api/searchStringsConstants');

let constFactory = {
    loginPage: loginPageConstants,
    //CMSReport: CMSReportConstants,
    //deviceMonitor: deviceMonitorConstants,
    //districtPage: districtPageConstants,
    siteMap: siteMapConstants,
    //unit: unitConstants,
    //caseDetails : caseDetailsConstants,
    profilePage : profilePageConstants,
    //devices : deviceConstants,
    //users : userConstants
    request: requestConstant,
    user: userConstants,
    searchString: searchStringConstants

    

}

module.exports.populateConstants = function () {
    
    Object.keys(constFactory).forEach((obj) => {        
        Object.keys(constFactory[obj]).forEach((key) => {            
            expect(key in constants, 'Duplication error: key: \'' + key + '\' was found more than once!').to.be.false;
            constants[key] = constFactory[obj][key];            
        })
    })
        
    return constants;
}
