const constantsPopulator = require('../../../src/common/constantsFactory');
const logger = require('../../../node_modules/@cellebrite/automation-loggers/loggerModule');

const ADMIN_USERNAME = 'admin';
const ADMIN_PASSWORD = 'AAb!12345';

module.exports = umsHooks = {

    beforeSessionTasks: () => {
        process.env.TS_NODE_PROJECT = './automation/tsconfig.json';
    },

    beforeFeatureTasks: async (feature) => {

        // login if needed
        if (feature.name !== "login page") {

            const { loginPage } = require('../../api_objects/loginPage'); // since it's typeScript, it has to be here and not at the top of the file

            try {
                await loginPage.loginToUmsByApi(ADMIN_USERNAME, ADMIN_PASSWORD);
            } catch (err) {
                logger.error(`Failed to login as admin. Error:\n ${err}`);
            }
        }                                            
    },

    beforeScenarioTasks: () => {
        global.timestamp = new Date().getTime();
    },

    beforeStepTasks: () => {
    },

    beforeTasks: (thisObj) => {
        // should be in "beforeSession" but the automationHook defined "runSettings" only now in "before"
        
        // populate constants  
        global.constants = constantsPopulator.populateConstants(); 

         // pass url to step definition functions
        let umsUrl = thisObj.runSettings.umsUrl;                     
        global.runSettings.umsUrl = `http://${umsUrl}`;  
    },

    afterStepTasks: () => {                
    },

    afterScenarioTasks: () => {
    }, 

    afterFeatureTasks: () => {
    }
}


