
Feature: Groups
    CRUD Groups
    
    @sanity 
    Scenario: Get a list of all groups
        And the request is: 
            """
                {       
                    "headers": {
                        "Content-Type": "application/json"
                    },
                    "json": true,   
                    "body": {}
                }

            """      
        When I get to "/v1/groups"
        Then response status code should be 200
    
    @sanity
    Scenario: Add new group
        And I create group name "group1" role "role1" app "app1" perm "perm1"
        When I get list of groups
        Then The group "group1" appears on list
    
    @sanity
    Scenario: Find group by ID
        And I create group name "group2" role "role2" app "app2" perm "perm2"
        When I search for group "group2"
        Then response status code should be 200
    
    @sanity
    Scenario: update group (positive)
        Given I create group name "group3" role "role3" app "app3" perm "perm3"
        When I update group "group3"
        Then response status code should be 200

    # the "response status code should be 200" checks for status code which never assigned 
    @need_review   
    Scenario: Find group roles by ID
        Given I create group name "group4" role "role4" app "app4" perm "perm4"
        When I Search roles for group "group4"
        Then response status code should be 200
        And amount of returned "roles" should be "1"

    @sanity
    Scenario: Add roles to group
        Given I create group name "group5" role "role5" app "app5" perm "perm5"
        And I create a role "roletoadd5" with permissions "permtoadd5"
        When I add role "roletoadd5" to group "group5"
        And I Search roles for group "group5"
        Then response status code should be 201
        And amount of returned "roles" should be "2"
    
    @sanity
    Scenario: Update roles in group
        Given I create group name "group6" role "role6" app "app6" perm "perm6"
        And I create a role "roletoapdate6" with permissions "permtoaupdate6"
        When I update role "roletoapdate6" to group "group6"
        And I Search roles for group "group6"
        Then response status code should be 201
        And amount of returned "roles" should be "1"
        And response contains value "roletoapdate6"
    
    @sanity
    Scenario: Add users to group
        Given I create group name "group7" role "role7" app "app7" perm "perm7"
        And I create user name "userfg7"
        When I add user "userfg7" to group "group7"
        Then response status code should be 201

    @need_review 
    Scenario: Delete group
        Given I create group name "grouptobedelted" role "roletobedelted" app "apptobedelted" perm "permtobedelted"
        When I delete group "group1"
        #Then group "group1" is deleted from the list 

