
Feature: users
    managed users

    @sanity
    Scenario: Create new user
        Given I create user name "user1"
        When I get list of users
        Then user "user1" appears on list

    @sanity
    Scenario: Check creating same user twice is not possible
        Given I create user name "user2"
        And I create again user name "user2"
        Then response status code should not be 201
    
    @sanity
    Scenario: Find user by id (positive)
        Given I create again user name "user3"
        When I search for user "user3"
        Then response status code should be 200
    
    @sanity
    Scenario: Find user that not exist by id (negative)
        Given I get list of users
        When I search for user that not exist
        Then response status code should be 404

    @sanity
    Scenario: update user (positive)
        Given I create user name "user4"
        When I update user "user4"
        Then response status code should be 200
    
    @sanity
    Scenario: update user that not exist (negative)
        Given I get list of users
        When I update user that not exist
        Then response status code should be 404
    
    @sanity
    Scenario: delete user
        Given I create user name "user5"
        When I delete user name "user5"
        Then response status code should be 204
    
    @sanity
    Scenario: find active users
        Given I create user name "Activeuser1"
        When I find "active" users
        Then only "active" users are returned
    
    @sanity
    Scenario: find disabled users
        Given I create user name "disableduser1"
        When I find "disabled" users
        Then only "disabled" users are returned

    @sanity
    Scenario: find deleted users
        Given I create user name "deletedduser1"
        When I find "deleted" users
        Then only "deleted" users are returned

    @sanity
    Scenario: search in users list by username
        Given I create user name "user987tobesearchfor"
        When I search for "searchstringlist1"
        Then only users that contains "searchstringlist1" were found

    @sanity
    Scenario: Disabling user
        Given I create user name "Activeuser1"
        When I change "Activeuser1" status to "disabled"
        Then "Activeuser1" status is "disabled"

    @sanity
    Scenario: activating disabled user
        Given I create user name "disableduser1"
        When I change "disableduser1" status to "active"
        Then "disableduser1" status is "active"

    @sanity 
    Scenario: check last login field is correctly updated in user
        Given I create user name "Activeuser1"
        When I try to login with valid user "Activeuser1" or password "lalala123!"
        And I am logged in With user "admin" and password "AAb!12345"
        Then last login field of user "Activeuser1" was updated correctly

    @need_review
    Scenario: Duplicate user
        Given I create user name "user5"
        When I press on "Duplicate"
        Then user name "user5" disableddsd fjhfjhfhg fhghhg
