import { defineSupportCode } from "cucumber";
import {expect} from "chai";
import {appPage} from "../../api_objects/appPage";
const rp = require("request-promise");
const logger = require("@cellebrite/automation-loggers/loggerModule");
declare const global: any;

defineSupportCode(({ Given, When, Then }) => {

    Given(/^I create application name "([^"]*)"$/,
        async function(appName) {
            appName = appName + global.timestamp;
            const res = await appPage.isAppExistByName(appName);
            if (!res) {
                await appPage.createAppByAPI(appName);
            }
        });

    When(/^I get list of application$/,
        async function() {
            this.appList = await appPage.getAppList().catch((error: string) => { logger.error("getlist error: " + error); });
        });

    When(/^I update application "([^"]*)"$/,
        async function(appName) {
            appName = appName + global.timestamp;
            this.appId = await appPage.getAppId(appName);
            this.responseJson = await appPage.updateApp(this.appId, appName);
        });

    Then(/^application "([^"]*)" appears on list$/,
        async function(appName) {
            appName = appName + global.timestamp;
            const res = await appPage.checkAppExistByName(this.appList, appName);
            // tslint:disable-next-line: no-unused-expression
            expect(res, `Error: ${appName} does not exist!`).to.be.true;
        });
});