import { defineSupportCode } from 'cucumber';
import {expect} from 'chai';
import {contextsPage} from '../../api_objects/contextsPage'
const logger = require('@cellebrite/automation-loggers/loggerModule');
declare const global : any;

defineSupportCode(({ Given, When, Then }) => {

    Given(/^I create a context "([^"]*)"$/,
        async function(contextName) {
            contextName = contextName + global.timestamp;
            const res = await contextsPage.isContextExistByName(contextName);
            if (!res) {
                await contextsPage.createContextByAPI(contextName);
            }
        });

    When(/^I get list of contexts$/,
        async function()  {
            this.contextList = await contextsPage.getContextsList();
        });

    Then(/^The context "([^"]*)" appears on list$/,
    async function(contextName) {
        contextName = contextName + global.timestamp;
        const res = await contextsPage.checkContextExistByName(this.contextList, contextName);
        // tslint:disable-next-line: no-unused-expression
        expect(res, `Error: ${contextName} does not exist!`).to.be.true;
    });
});
