import { defineSupportCode } from "cucumber";
import { loginPage } from "../../api_objects/loginPage";
const featureWorld = require("@cellebrite/automation-wdio-helpers/featureWorld");
import { expect } from "chai";
declare const constants: any;
declare const global: any;
const logger = require("@cellebrite/automation-loggers/loggerModule");

defineSupportCode(({ Given, When, Then }) => {

    Given(/^I am logged in With user "([^"]*)" and password "([^"]*)"$/,
        async function(userName, password) {
            await loginPage.loginToUmsByApi(userName, password);
        });

    Given(/^I try to login with (.*) user "([^"]*)" or password "([^"]*)"$/,
        async function(loginToFail, userName, password) {
            if (userName !== "admin") {
                userName = userName + global.timestamp;
            }
            await loginPage.loginToUmsByApi(userName, password);
        });

    Then(/^I was( not)* logged in$/,
        async function(shouldLogin) {
            let loginTosuccess = shouldLogin;
            loginTosuccess === "not" ? loginTosuccess = false : loginTosuccess = true;
            const res = featureWorld.loginsucceed !== loginTosuccess;
            if (res) {
                expect(res, `error: you are ${shouldLogin} login`).to.be.true;
            }
        });
});
