import { defineSupportCode } from 'cucumber';

var rp = require('request-promise');
//const profilePage = require('../../api_objects/profilePage');
const scenarioWorld = require('../../../node_modules/@cellebrite/automation-wdio-helpers/scenarioWorld');
import { appPage } from '../../api_objects/appPage';
import { permissionPage } from '../../api_objects/permissionPage';
import { rolePage } from '../../api_objects/rolePage';
import { profilePage } from '../../api_objects/profilePage'
const logger = require('@cellebrite/automation-loggers/loggerModule');
import { expect } from 'chai';
declare const global: any;
declare const constants: any;
defineSupportCode(({ Given, When, Then }) => {

    Given(/^I create a( predefined)* role "([^"]*)" with permissions "([^"]*)"$/,
        async function(predefined, roleName, permName) {

            if (predefined) {
                predefined = true;
            }
            else {
                predefined = false;
            }
            roleName = roleName + global.timestamp;
            const appName = "my_app" + global.timestamp;
            permName = permName + global.timestamp;

            await appPage.initApp(appName);
            this.appId = scenarioWorld.appId;
            this.appKey = scenarioWorld.appKey;

            await permissionPage.initPerm(permName, this.appId, this.appKey);
            this.permId = scenarioWorld.permId;
            this.permKey = scenarioWorld.permKey;

            await rolePage.initRole(roleName, this.permId);

        });

    When(/^I get list of roles$/,
        async function() {
            this.rolesList = await rolePage.getRolesList();
        });

    When(/^I get a role "([^"]*)" with its permissions$/,
        async function(roleName) {
            roleName = roleName + global.timestamp;
            let roleId = await rolePage.getRoleId(roleName);
            roleId = Number(roleId);
            this.rolesList = await rolePage.getRolesListWithPermissions(roleId);
        });

    When(/^I update role "([^"]*)" with permissions "([^"]*)"$/,
        async function(roleName, permName) {
            roleName = roleName + global.timestamp;
            permName = permName + global.timestamp;
            const permId = await permissionPage.getPermId(permName);
            const roleId = await rolePage.getRoleId(roleName);
            this.responseJson = await rolePage.updateRole(roleId, permId);
        });

    When(/^I add role "([^"]*)" to user "([^"]*)"$/,
        async function(roleName, userName) {
            roleName = roleName + global.timestamp;
            const uniqueUserName = userName + global.timestamp;
            const user = constants[userName];
            const roleId = scenarioWorld.roleId;
            const userId = scenarioWorld.userId;
            user.roles.id = roleId;
            if (roleId > -1 && userId > -1) {
                this.responseJson = await profilePage.updateUser(userId, uniqueUserName, user);
            }
        });
    Then(/^permissions "([^"]*)" of role "([^"]*)" are listed$/,
    async function(permissionName, roleName) {
        permissionName = permissionName + global.timestamp;
        roleName = roleName + global.timestamp;
        if ((roleName !== this.rolesList[0].name) && (permissionName !== this.rolesList[0].permissions[0].name)) {
            // tslint:disable-next-line: no-unused-expression
            expect(false, `Error: ${roleName} and permName ${permissionName} returned by server are wrong `).to.be.true;
        }
    });

    Then(/^The role "([^"]*)" appears on list$/,
        async function(roleName) {
            roleName = roleName + global.timestamp;
            const res = await rolePage.checkRoleExistByName(this.rolesList, roleName);
            // tslint:disable-next-line: no-unused-expression
            expect(res, `Error: ${roleName} does not exist!`).to.be.true;
        });
});